/*
 *  Copyright (C) 2006 CSIRO Australia
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  
 *  - Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *  
 *  - Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  
 *  - Neither the name of the CSIRO nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 *  PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE ORGANISATION OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "phpanx_util.h"
#include "phpannodex.h"

static void anx_destruction_handler(zend_rsrc_list_entry *rsrc TSRMLS_DC);

/* This array tells php what functions this extension provides. The functions
 * are grouped according to which file they are located in and encapsulated in
 * hash defines. This is so that disabling functions from a particular file is
 * as simple as commenting out the relevant header file.
 */
static function_entry phpannodex_functions[] = {

	/* Functions defined in anx_general.h of the original Annodex libraries,
	 * and phpanx_general.h of the phpannodex extension.
	 */
#ifdef PHPANX_GENERAL_H
	PHPANX_GENERAL_FUNCTIONS
#endif

	/* Functions defined in anx_read.h of the original Annodex libraries,
	 * and phpanx_read.h of the phpannodex extension.
	 */
#ifdef PHPANX_READ_H
	PHPANX_READ_FUNCTIONS
#endif

	/* Functions defined in anx_write.h of the original Annodex libraries,
	 * and phpanx_write.h of the phpannodex extension.
	 */
#ifdef PHPANX_WRITE_H
	PHPANX_WRITE_FUNCTIONS
#endif

	/* Functions defined in anx_write.h of the original Annodex libraries,
	 * and phpanx_write.h of the phpannodex extension.
	 */
#ifdef PHPANX_TYPES_H
	PHPANX_TYPES_FUNCTIONS
#endif
	
	{NULL, NULL, NULL}
};

zend_module_entry phpannodex_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
	STANDARD_MODULE_HEADER,
#endif
	PHPANNODEX_EXTNAME,
	phpannodex_functions,
	PHP_MINIT(phpanx_init), 	
	NULL,
	NULL,
	NULL,
	NULL,
#if ZEND_MODULE_API_NO >= 20010901
	PHPANNODEX_VERSION,
#endif
	STANDARD_MODULE_PROPERTIES
};

#ifdef COMPILE_DL_PHPANNODEX
ZEND_GET_MODULE(phpannodex)
#endif

PHP_MINIT_FUNCTION(phpanx_init) {

	init_constants( module_number TSRMLS_CC  ); // The args are declared 
					 	  // inside PHP_MINIT_FUNCTION()
	register_anx_resource( (int) module_number );

	return;
}

void register_anx_resource( int module_number ) {

	le_anx_handle = zend_register_list_destructors_ex( 
			anx_destruction_handler, NULL, LE_ANX_HANDLE_NAME, 
			module_number);

	return;
}
	
void anx_destruction_handler(zend_rsrc_list_entry *rsrc TSRMLS_DC) {

	ANNODEX* anx = (ANNODEX*) rsrc->ptr;
//	anx_close( anx );
	return;
}
